/*******************************************************************
Name        = cam_server.c
Description = Server to get the camera pictures from an Unreal Client 
              and send them over a socket.
Author      = Jochen Sprickerhof
Date        = 2005
*******************************************************************/
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <unistd.h>
#include <stdio.h>

// the maximal size of the screenshot
#define BUFFER_SIZE         1000000

// the server port
#define PORT                7766

// main loop for the server
int main(int argc, char* argv[]) {
  //socket variables
  int hSocket,hServerSocket;
  struct sockaddr_in Address;
  int nAddressSize=sizeof(struct sockaddr_in);
  int socket_return;
  // buffers
  FILE *cam;
  char sBuffer[1];
  char pBuffer[BUFFER_SIZE];
  int byte_read=0;
  
  /* make a socket */
  hServerSocket=socket(AF_INET, SOCK_STREAM, 0);
  
  if(hServerSocket == -1) {
    printf("\nCould not create a socket\n");
    return 0;
  }
  
  /* fill address struct */
  Address.sin_addr.s_addr = INADDR_ANY;
  Address.sin_port        = htons(PORT);
  Address.sin_family      = AF_INET;

  /* bind to a port */
  if(bind(hServerSocket, (struct sockaddr*)&Address, sizeof(Address)) == -1) {
    printf("\nCould not bind to address\n");
    return 0;
  }

  /* establish listen queue */
  if(listen(hServerSocket,1) == -1) {
    printf("\nCould not listen\n");
    return 0;
  }

  // loop for client connections
  for(;;) {
    /* get the connected socket */
    hSocket = accept(hServerSocket, (struct sockaddr*)&Address, (socklen_t *)&nAddressSize);
    // loop for connected client
    for(;;) {
      /* read commad from client */
      socket_return = read(hSocket,sBuffer,1);
      if(socket_return > 0 && sBuffer[0] == 'G') {
	   /* grab screenshoot from Unreal Window */
	   cam = popen("xwd -name \"Unreal Tournament 2003\" -nobdrs -silent | xwdtopnm 2>/dev/null | pnmtojpeg","r");
	   byte_read = fread(pBuffer, 1, BUFFER_SIZE, cam);
	   pclose(cam);
	   /* send screenshoot to client */
	   send(hSocket, pBuffer, byte_read, 0);
      }
      else
	   break;
    }
  }
}
